import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import javax.sql.*;
import javax.naming.*;
import eshop.*;

public class PrefferedPriceFilter implements Filter {
	private int threshold = 0;
	private DataSource ds = null;
	
	public void init(FilterConfig fc){
		//	D҉io
		threshold = Integer.parseInt(fc.getInitParameter("Threshold"));

		//	DBANZXpDataSource擾Ă
        try {
			InitialContext ic = new InitialContext();
			ds = (DataSource)ic.lookup("java:comp/env/jdbc/eshop");
        } catch(Exception ex) {
            ex.printStackTrace();
        }
	}

	public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain) 
					throws ServletException, IOException {
		HttpServletRequest httpreq = (HttpServletRequest)req;
		String user = httpreq.getRemoteUser();

		//	̃[U̍wт߂
		int order = 0;
		try {
			Connection con = ds.getConnection();
			Statement stmt = con.createStatement();
			ResultSet rs = stmt.executeQuery(
				"select eshop_ordertotal from eshop_users where eshop_username='"
				+ user + "'");
			if (rs.next()){
				order = rs.getInt(1);
			}
			con.close();
		} catch (SQLException ex){
			ex.printStackTrace();
		}
		System.out.println("user=" + user + ", eshop_ordertotal=" + order);

		//	ZbVɌѕtĂloginInfoXV
		HttpSession session = httpreq.getSession(true);
        LoginInfo loginInfo = (LoginInfo)session.getAttribute("loginInfo");
        if (loginInfo == null){
        	loginInfo = new LoginInfo();
        	loginInfo.setName(user);
        	session.setAttribute("loginInfo", loginInfo);
        }
		if (threshold < order){
			loginInfo.setPreferred(true);
		} else {
			loginInfo.setPreferred(false);
		}
		
		//	ANZXꂽ\[X̌Ăяo
		chain.doFilter(req, res);
	}

	public void destroy(){}	
}
