import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import eshop.*;

public class BaseServlet extends HttpServlet {
	ArrayList listOfItems = null;
	
	public void init(){
        if(listOfItems == null) {
            listOfItems = new ArrayList();
			listOfItems.add(new Item("A", 100, 80 , 10));
			listOfItems.add(new Item("B", 200, 160 , 20));
			listOfItems.add(new Item("C", 300, 240 , 30));
        }
	}
	
	public void doIt(HttpServletRequest req, HttpServletResponse res, String jsp) 
		throws ServletException, IOException {
		
 		ServletContext sc = getServletContext();
		sc.setAttribute("listOfItems", listOfItems);
		RequestDispatcher rd = sc.getRequestDispatcher(jsp);
		rd.forward(req, res);
	}
}
