package eshop;
import javax.ejb.*;
import javax.naming.*;
import java.rmi.*;

public abstract class ItemBean implements EntityBean {
	private EntityContext ec = null;

	public abstract String getName();
	public abstract void setName(String name);
	public abstract int getPrice();
	public abstract void setPrice(int price);
	public abstract int getPreferredprice();
	public abstract void setPreferredprice(int preferredprice);
	public abstract int getQtystock();
	public abstract void setQtystock(int qtystock);

	public String ejbCreate(String name, int price, int preferredprice, int qtystock)
		throws CreateException {
System.out.println("getName()=" + ec.getCallerPrincipal().getName());
System.out.println("isCallerInRole(dummy)=" 
	+ (ec.isCallerInRole("dummy") ? "true" : "false"));
System.out.println("isCallerInRole(staff)=" 
	+ (ec.isCallerInRole("staff") ? "true" : "false"));
System.out.println("isCallerInRole(boss)=" 
	+ (ec.isCallerInRole("boss") ? "true" : "false"));

		setName(name);
		setPrice(price);
		setPreferredprice(preferredprice);
		setQtystock(qtystock);

  		return name;
	}
	public void ejbPostCreate(String name, int price, int preferredprice, int qtystock){}

	public void setEntityContext(EntityContext ec) {
		this.ec = ec;
	}
	public void unsetEntityContext() {
		this.ec = null;
	}
	public void ejbStore() {}
	public void ejbActivate() {} 
	public void ejbPassivate() {} 
	public void ejbLoad() {} 
	public void ejbRemove() {} 
}
